import Database from "../../../../../Components/common/DAsyncStorage";
import NetInfo from "@react-native-community/netinfo";
import { is2Wflow } from "react-native-digitcamera/src/common/Constants";
import { measureConnectionSpeed } from "react-native-network-bandwith-speed";

// save data in realm
export const offlinePIDataToRealm = async (isPIDone) => {
  try {
    const mediaStatusObjs = await Database.get("PIMediaStatus");
    const vechicleData = await Database.get("PIVechicleData");
    console.log(
      "!is2Wflow(vechicleData?.activityTypeId)  isPIDone",
      !is2Wflow(vechicleData?.activityTypeId),
      isPIDone
    );
    if (!is2Wflow(vechicleData?.activityTypeId) || isPIDone) {
      console.log("In if offlinePIDataToRealm ");
      let offlineImageData = [];
      console.log(
        "CommonFunc  offlinePIDataToRealm() mediaStatusObjs \n\n\n ",
        mediaStatusObjs
      );
      offlineImageData = [];
      mediaStatusObjs?.filter((item) => {
        if (item?.status === "failed") {
          offlineImageData.push(item);
        }
      });

      await Database.set("PIOfflineVechicleData", {
        activityId: vechicleData.activityId,
        registrationNumber: vechicleData.licensePlateNumber,
        quoteNumber: vechicleData.quoteNumber,
        dataTobeUploaded: JSON.stringify(offlineImageData),
        isPICompleted: isPIDone,
      });
    } else {
      console.log("In else offlinePIDataToRealm ");
    }
  } catch (error) {
    console.log("***** offlinePIDataToRealm catch ", error);
  }
};

// checking internet
export const checkInternet = async () => {
  const state = await NetInfo.fetch();
  console.log("Connection type", state.type);
  console.log("Is connected?", state.isConnected);
  return state.isConnected;
};

export const checkInternetSpeed = async () => {
  const DataSpeed = await measureConnectionSpeed();
  console.log(
    "%%%%%%%%%%%% DataSpeed %%%%%%",
    JSON.stringify(DataSpeed, null, "  "),
    DataSpeed?.speed * 1024
  );
  var kbps = DataSpeed?.speed * 1024;
  if (kbps >= 100) {
    return true;
  }
  return false;
};
// make desion for offline/online flow
export const checkFlow = () => {};

export const clearAllRealmData = async () => {
  try {
    await Database.remove("PIOfflineData");
    await Database.remove("PIVechicleData");
    await Database.remove("PIVechicleInstruction");

    await Database.update("PIGonePoseDetection", {
      GoneposeDetectionCount: 0,
    });

    await Database.update("PIPoseDetectionCompleted", {
      poseDetectionCompletedCount: 0,
    });

    await Database.update("PIRetryCount", {
      retryCount: 0,
      index: 0,
      isAddNewImageData: false,
    });

    await Database.update("PIclickedCount", {
      clickedCount: 0,
    });

    await Database.update("PIUploadedCount", {
      uploadedCount: 0,
    });
    await Database.remove("PIMediaStatus");
    await Database.remove("PIVideoCompleteStatus");
  } catch (error) {}
};

export const updateStatusRealm = async (uri, DocumentImageName, newStatus) => {
  var PIVechicleData = await Database.get("PIVechicleData");
  console.log(
    "CommonFunc.js  updateStatusRealm() PIVechicleDat?.activityId ",
    PIVechicleData?.activityId
  );
  var activityId = PIVechicleData?.activityId;
  var quoteNumber = PIVechicleData?.quoteNumber;
  var licensePlateNumber = PIVechicleData?.licensePlateNumber;
  await initStatusRealm(
    uri,
    DocumentImageName,
    activityId,
    quoteNumber,
    licensePlateNumber
  ).then(async () => {
    const uploadObj = await Database.get("PIMediaStatus");
    console.log(
      "*** CommonFunc.js updateStatusRealm before update status uploadObj: " +
        JSON.stringify(uploadObj),
      newStatus
    );

    if (uploadObj != null) {
      var newObj;
      if (uploadObj instanceof Array) {
        newObj = uploadObj.map((obj) =>
          obj.imageName === DocumentImageName
            ? {
                ...obj,
                imageName: DocumentImageName,
                status: newStatus,
                activityId,
              }
            : obj
        );
      } else {
        newObj = [
          {
            ...uploadObj,
            activityId,
            imageName: DocumentImageName,
            status: newStatus,
          },
        ];
      }
      console.log(
        "*** CommonFunc.js updateStatusRealm newObj: " + JSON.stringify(newObj)
      );
      await Database.set("PIMediaStatus", newObj);
      const alog = await Database.get("PIMediaStatus");
      const aoffline = await Database.get("PIOfflineVechicleData");
      console.log(
        "Media Status Obj updateStatusRealm  PIMediaStatus ",
        JSON.stringify(alog, null, "  ")
      );
      console.log(
        "PIOfflineVechicleData updateStatusRealm  PIOfflineVechicleData ",
        JSON.stringify(aoffline, null, "  ")
      );
    }
  });
};

const addMediaStatusObj = (oldStatus, myObj) => {
  console.log(
    "**** addMediaStatusObj ",
    typeof oldStatus,
    typeof myObj,
    JSON.stringify(oldStatus),
    JSON.stringify(myObj)
  );
  console.log("0 " + myObj);
  var newObj;
  if (oldStatus == null || oldStatus == undefined) {
    console.log("oldStatus == null || oldStatus == undefined", myObj);
    return [myObj];
  }
  if (oldStatus instanceof Array) {
    var isImageExist;
    oldStatus.map((imageItemToupdate) => {
      // if already object present
      if (Object.values(imageItemToupdate).includes(myObj.imageName)) {
        return (isImageExist = true);
      }
      console.log(
        "CommonFunctions.js >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>",
        isImageExist
      );
    });
    if (isImageExist) {
      console.log("*******CommonFunc.js Object already in DB");
      newObj = oldStatus.filter(
        (imageItemToupdate) => imageItemToupdate.imageName != myObj.imageName
      ); // removing previous obj
      console.log(
        "In CommonFunc.js removed Previous Object",
        JSON.stringify(newObj, null, "  ")
      );
      newObj = [...newObj, myObj]; // adding new
      console.log(
        "In CommonFunc.js added with new Object",
        JSON.stringify(newObj, null, "  ")
      );
    } else {
      // no previous obj
      // adding new obj
      newObj = [...oldStatus, myObj];
      console.log("CommonFunc.js oldStatus instanceof Array Added", newObj);
    }
  } else {
    console.log("********** **********   In else ");
    if (oldStatus != undefined || oldStatus != null) {
      newObj = [oldStatus, myObj];
      console.log(
        "******* oldStatus != undefined || oldStatus != null",
        newObj
      );
    } else {
      newObj = [myObj];
      console.log("******* newObj = [myObj]", newObj);
    }
  }
  return newObj;
};

const initStatusRealm = async (
  uri,
  DocumentImageName,
  activityId,
  quoteNumber,
  licensePlateNumber
) => {
  const oldStatus = await Database.get("PIMediaStatus");
  const myObj = {
    status: "uploading", // uploading, uploaded, failed
    uri: uri,
    imageName: DocumentImageName,
    activityId: activityId,
    quoteNumber: quoteNumber,
    regNumber: licensePlateNumber,
  };
  const newObj = addMediaStatusObj(oldStatus, myObj);
  console.log(
    ")))))))))))))))))))))))))))))))))))))))))))))",
    JSON.stringify(newObj, null, "  ")
  );
  // don't change set to update as we are adding new Obj.
  await Database.set("PIMediaStatus", newObj);
  const PIMediaStatus = await Database.get("PIMediaStatus");
  console.log("PIMediaStatus initStatusRealm" + JSON.stringify(PIMediaStatus));
};
